'use strict';

var _should = require('should');

var _should2 = _interopRequireDefault(_should);

var _Posts = require('../collections/Posts');

var _Posts2 = _interopRequireDefault(_Posts);

var _Authors = require('../collections/Authors');

var _Authors2 = _interopRequireDefault(_Authors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// eslint-disable-line

var _firenze = firenze; /* global describe, before, after, it, firenze, firenzeConfig */
/* eslint-disable no-invalid-this */

var Database = _firenze.Database;

describe('Adapter', function () {
  before(function () {
    this.db = new Database(firenzeConfig);
    this.Posts = (0, _Posts2.default)(this.db);
    this.Authors = (0, _Authors2.default)(this.db);
  });

  after(function (done) {
    this.db.close().then(done);
  });

  it('should load fixtures for a single Collection', function (done) {
    var posts = new this.Posts();
    var data = require('../fixtures/posts');
    this.db.getAdapter().loadFixture(posts, data).then(function () {
      done();
    }).catch(function (error) {
      throw error;
    });
  });

  it('should load fixtures for multiple collections', function (done) {
    this.db.getAdapter().loadAllFixtures([{
      collection: new this.Posts(),
      rows: require('../fixtures/posts')
    }, {
      collection: new this.Authors(),
      rows: require('../fixtures/authors')
    }]).then(function () {
      done();
    }).catch(function (error) {
      throw error;
    });
  });
});