'use strict';

var _shouldPromised = require('should-promised');

var _shouldPromised2 = _interopRequireDefault(_shouldPromised);

var _Posts = require('../collections/Posts');

var _Posts2 = _interopRequireDefault(_Posts);

var _Authors = require('../collections/Authors');

var _Authors2 = _interopRequireDefault(_Authors);

var _posts = require('../fixtures/posts');

var _posts2 = _interopRequireDefault(_posts);

var _authors = require('../fixtures/authors');

var _authors2 = _interopRequireDefault(_authors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// eslint-disable-line

var _firenze = firenze; /* global describe, before, after, it, firenze, firenzeConfig */
/* eslint-disable no-unused-expressions, no-invalid-this */

var Database = _firenze.Database;

describe('Behavior', function () {
  before(function (done) {
    this.db = new Database(firenzeConfig);

    this.Posts = (0, _Posts2.default)(this.db);
    this.postsData = _posts2.default;

    this.Authors = (0, _Authors2.default)(this.db);
    this.authorsData = _authors2.default;

    this.db.getAdapter().loadAllFixtures([{
      collection: new this.Posts(),
      rows: this.postsData
    }, {
      collection: new this.Authors(),
      rows: this.authorsData
    }]).then(function () {
      done();
    }).catch(function (error) {
      throw error;
    });
  });

  after(function (done) {
    this.db.close().then(done);
  });

  it('should load in collection', function () {
    var posts = new this.Posts();
    posts.loadedBehaviors.length.should.eql(1);
  });

  it('should fire sync callback in model', function () {
    var posts = new this.Posts();
    var post = posts.model({
      title: 'New Post',
      body: 'text...'
    });

    post.get('created').should.be.instanceOf(Date);
  });

  it('should fire async callback in model', function (done) {
    var posts = new this.Posts();
    var post = posts.model({
      title: 'New Post',
      body: 'text...'
    });

    post.save().then(function (model) {
      model.get('updated').should.be.instanceOf(Date);
    }).finally(done);
  });
});