'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (db) {
  return db.createCollection({
    table: 'authors',

    modelClass: _Author2.default,

    alias: 'Author',

    displayField: 'name',

    schema: {
      id: {
        type: 'increments'
      },
      name: {
        type: 'string'
      },
      bio: {
        type: 'text'
      },
      country: {
        type: 'string'
      }
    },

    behaviors: [{
      class: _Timestamp2.default,
      options: {}
    }],

    beforeDelete: function beforeDelete() {
      return new _.Promise.reject(true);
    },
    afterDelete: function afterDelete(model) {
      return new _.Promise(function (resolve, reject) {
        model.set('title', 'Deleted');
        reject(true);
      });
    }
  });
};

var _ = require('../../');

var _Timestamp = require('../behaviors/Timestamp');

var _Timestamp2 = _interopRequireDefault(_Timestamp);

var _Author = require('../models/Author');

var _Author2 = _interopRequireDefault(_Author);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }