'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (db) {
  return db.createCollection({
    table: 'posts',

    modelClass: _Post2.default,

    alias: 'Post',

    displayField: 'title',

    schema: {
      id: {
        type: 'increments'
      },
      author_id: { //eslint-disable-line
        type: 'integer'
      },
      title: {
        type: 'string'
      },
      body: {
        type: 'text'
      },
      views: {
        type: 'integer'
      },
      note: {
        type: 'string'
      },
      created: {
        type: 'datetime'
      },
      updated: {
        type: 'datetime'
      }
    },

    behaviors: [_Timestamp2.default],

    afterDelete: function afterDelete(model) {
      model.set('_field', 'afterDelete');
      return new _.Promise.resolve(true);
    }
  });
};

var _ = require('../../');

var _Timestamp = require('../behaviors/Timestamp');

var _Timestamp2 = _interopRequireDefault(_Timestamp);

var _Post = require('../models/Post');

var _Post2 = _interopRequireDefault(_Post);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }