'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _Sql = require('../../lib/adapters/Sql');

var _Sql2 = _interopRequireDefault(_Sql);

var _Memory = require('../../lib/adapters/Memory');

var _Memory2 = _interopRequireDefault(_Memory);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Mysql = {
  adapter: _Sql2.default,

  host: process.env.FIRENZE_DB_HOST || '127.0.0.1',
  user: process.env.FIRENZE_DB_USER || 'root',
  port: process.env.FIRENZE_DB_PORT || 3306,
  password: process.env.FIRENZE_DB_PASS || '',
  database: process.env.FIRENZE_DB || 'firenze',

  pool: {
    min: 0,
    max: 5
  }
};

var Memory = {
  adapter: _Memory2.default
};

exports.default = {
  Mysql: Mysql,
  Memory: Memory
};