'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _async = require('async');

var _async2 = _interopRequireDefault(_async);

var _Promise = require('./Promise');

var _Promise2 = _interopRequireDefault(_Promise);

var _Query = require('./Query');

var _Query2 = _interopRequireDefault(_Query);

var _Schema = require('./Schema');

var _Schema2 = _interopRequireDefault(_Schema);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Adapter = (function () {
  function Adapter() {
    var extend = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

    _classCallCheck(this, Adapter);

    //eslint-disable-line
    this.queryClass = _Query2.default;
    this.schemaClass = _Schema2.default;

    _lodash2.default.merge(this, extend);
  }

  _createClass(Adapter, [{
    key: 'getConnection',
    value: function getConnection() {
      return null;
    }
  }, {
    key: 'closeConnection',
    value: function closeConnection() {
      return new _Promise2.default(function (resolve) {
        return resolve();
      });
    }
  }, {
    key: 'query',
    value: function query() {
      var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

      return new this.queryClass(_extends({}, options, {
        adapter: this
      }));
    }
  }, {
    key: 'schema',
    value: function schema() {
      return new this.schemaClass(this);
    }
  }, {
    key: 'populateTable',
    value: function populateTable(collection, rows) {
      var _this = this;

      return new _Promise2.default(function (resolve, reject) {
        _this.query().table(collection.table).create(rows).run().then(resolve).catch(reject);
      });
    }
  }, {
    key: 'loadFixture',
    value: function loadFixture(collection, rows) {
      var _this2 = this;

      //eslint-disable-line
      return new _Promise2.default(function (resolve, reject) {
        _async2.default.series([function (callback) {
          _this2.schema().dropTableOfCollection(collection).then(function (response) {
            callback(null, response);
          }).catch(function (error) {
            callback(error);
          });
        }, function (callback) {
          _this2.schema().createTableFromCollection(collection).then(function (response) {
            callback(null, response);
          }).catch(function (error) {
            callback(error);
          });
        }, function (callback) {
          _this2.populateTable(collection, rows).then(function (response) {
            callback(null, response);
          }).catch(function (error) {
            callback(error);
          });
        }], function (err, results) {
          if (err) {
            return reject(err);
          }

          return resolve(results);
        });
      });
    }
  }, {
    key: 'loadAllFixtures',
    value: function loadAllFixtures(arr) {
      var _this3 = this;

      //eslint-disable-line
      return new _Promise2.default(function (resolve, reject) {
        _async2.default.map(arr, function (fixture, callback) {
          _this3.loadFixture(fixture.collection, fixture.rows).then(function (results) {
            callback(null, results);
          }).catch(function (error) {
            callback(error);
          });
        }, function (err, results) {
          if (err) {
            return reject(err);
          }

          return resolve(results);
        });
      });
    }
  }]);

  return Adapter;
})();

exports.default = Adapter;