'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _collectionFactory = require('./common/collectionFactory');

var _collectionFactory2 = _interopRequireDefault(_collectionFactory);

var _Promise = require('./Promise');

var _Promise2 = _interopRequireDefault(_Promise);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Database = (function () {
  function Database() {
    var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

    _classCallCheck(this, Database);

    this.defaultOptions = {
      adapter: null,
      host: null,
      user: null,
      database: null,
      password: null,
      prefix: null
    };

    this.options = _lodash2.default.merge(this.defaultOptions, options);

    var AdapterClass = this.options.adapter;
    this.adapter = new AdapterClass(_lodash2.default.omit(this.options, 'adapter'));

    this.createCollection = (0, _collectionFactory2.default)(this);
  }

  _createClass(Database, [{
    key: 'getAdapter',
    value: function getAdapter() {
      return this.adapter;
    }
  }, {
    key: 'query',
    value: function query() {
      return this.adapter.query();
    }
  }, {
    key: 'schema',
    value: function schema() {
      return this.adapter.schema();
    }
  }, {
    key: 'getConnection',
    value: function getConnection() {
      return this.getAdapter().getConnection();
    }
  }, {
    key: 'close',
    value: function close() {
      var _this = this;

      return new _Promise2.default(function (resolve) {
        return _this.getAdapter().closeConnection().then(function () {
          return resolve();
        });
      });
    }
  }]);

  return Database;
})();

exports.default = Database;