'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })(); /* eslint-disable new-cap */

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _Promise = require('./Promise');

var _Promise2 = _interopRequireDefault(_Promise);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Model = (function () {
  function Model() {
    var attributes = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
    var extend = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

    _classCallCheck(this, Model);

    this.attributes = attributes ? attributes : {};
    this.id = null;

    _lodash2.default.merge(this, extend);

    var id = this.get(this.collection.primaryKey);
    if (id) {
      this.id = id;
    }

    this.collection.callBehavedMethod(this, 'modelInitialize');
  }

  _createClass(Model, [{
    key: 'get',
    value: function get(field) {
      var obj = this.toObject();
      return _lodash2.default.get(obj, field);
    }
  }, {
    key: 'set',
    value: function set(field, value) {
      if (_lodash2.default.isObject(field)) {
        return _lodash2.default.merge(this.attributes, field);
      }

      return _lodash2.default.set(this.attributes, field, value);
    }
  }, {
    key: 'toObject',
    value: function toObject() {
      return this.attributes;
    }
  }, {
    key: 'toJSON',
    value: function toJSON() {
      return this.toObject();
    }
  }, {
    key: 'fetch',
    value: function fetch() {
      var _this = this;

      var id = this.getId();
      if (!id) {
        throw new Error('No ID found');
      }

      return new _Promise2.default(function (resolve, reject) {
        return _this.collection.findById(id).then(function (model) {
          resolve(model);
        }).catch(reject);
      });
    }
  }, {
    key: 'getId',
    value: function getId() {
      var id = this.id || this.get(this.collection.primaryKey);
      if (!_lodash2.default.isUndefined(id)) {
        return id;
      }

      return null;
    }
  }, {
    key: 'isNew',
    value: function isNew() {
      return this.getId() ? false : true; // eslint-disable-line
    }
  }, {
    key: 'save',
    value: function save() {
      var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

      return this.collection.save(this, options);
    }
  }, {
    key: 'saveField',
    value: function saveField(field, value) {
      this.set(field, value);

      return this.save({
        fields: [field]
      });
    }
  }, {
    key: 'clear',
    value: function clear() {
      this.id = null;
      this.attributes = {};
    }
  }, {
    key: 'delete',
    value: function _delete() {
      var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

      return this.collection.delete(this, options);
    }
  }, {
    key: 'validate',
    value: function validate() {
      var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

      return this.collection.validate(this, options);
    }
  }, {
    key: 'validateField',
    value: function validateField(field) {
      var value = arguments.length <= 1 || arguments[1] === undefined ? null : arguments[1];

      return this.collection.validateField(this, field, value);
    }
  }]);

  return Model;
})();

exports.default = Model;