'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _Promise = require('./Promise');

var _Promise2 = _interopRequireDefault(_Promise);

var _Expression = require('./Expression');

var _Expression2 = _interopRequireDefault(_Expression);

var _Functions = require('./Functions');

var _Functions2 = _interopRequireDefault(_Functions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { return obj && typeof Symbol !== "undefined" && obj.constructor === Symbol ? "symbol" : typeof obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Query = (function () {
  function Query() {
    var givenOptions = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

    _classCallCheck(this, Query);

    var options = _extends({
      expressionClass: _Expression2.default,
      functionsClass: _Functions2.default
    }, givenOptions);

    this.adapter = null;
    this.collection = null;

    if (options.adapter) {
      this.setAdapter(options.adapter);
    }

    if (options.collection) {
      this.setCollection(options.collection);
    }

    this.options = _lodash2.default.omit(options, 'adapter', 'collection');
  }

  _createClass(Query, [{
    key: 'setAdapter',
    value: function setAdapter(adapter) {
      this.adapter = adapter;

      return this;
    }
  }, {
    key: 'getAdapter',
    value: function getAdapter() {
      return this.adapter;
    }
  }, {
    key: 'setCollection',
    value: function setCollection(collection) {
      this.collection = collection;

      return this;
    }
  }, {
    key: 'select',
    value: function select() {
      return this;
    }
  }, {
    key: 'distinct',
    value: function distinct() {
      return this;
    }
  }, {
    key: 'from',
    value: function from() {
      return this;
    }
  }, {
    key: 'where',
    value: function where() {
      return this;
    }
  }, {
    key: 'andWhere',
    value: function andWhere() {
      return this;
    }
  }, {
    key: 'orWhere',
    value: function orWhere() {
      return this;
    }
  }, {
    key: 'notWhere',
    value: function notWhere() {
      return this;
    }
  }, {
    key: 'groupBy',
    value: function groupBy() {
      return this;
    }
  }, {
    key: 'orderBy',
    value: function orderBy() {
      return this;
    }
  }, {
    key: 'offset',
    value: function offset() {
      return this;
    }
  }, {
    key: 'limit',
    value: function limit() {
      return this;
    }
  }, {
    key: 'page',
    value: function page() {
      return this;
    }
  }, {
    key: 'create',
    value: function create() {
      return this;
    }
  }, {
    key: 'update',
    value: function update() {
      return this;
    }
  }, {
    key: 'delete',
    value: function _delete() {
      return this;
    }
  }, {
    key: 'table',
    value: function table() {
      return this;
    }
  }, {
    key: 'expr',
    value: function expr() {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return new (Function.prototype.bind.apply(this.options.expressionClass, [null].concat([this], args)))();
    }
  }, {
    key: 'func',
    value: function func() {
      for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      return new (Function.prototype.bind.apply(this.options.functionsClass, [null].concat([this], args)))();
    }
  }, {
    key: 'count',
    value: function count() {
      return this;
    }
  }, {
    key: 'truncate',
    value: function truncate() {
      return this;
    }
  }, {
    key: 'join',
    value: function join() {
      return this;
    }
  }, {
    key: 'innerJoin',
    value: function innerJoin() {
      return this;
    }
  }, {
    key: 'leftJoin',
    value: function leftJoin() {
      return this;
    }
  }, {
    key: 'leftOuterJoin',
    value: function leftOuterJoin() {
      return this;
    }
  }, {
    key: 'rightJoin',
    value: function rightJoin() {
      return this;
    }
  }, {
    key: 'rightOuterJoin',
    value: function rightOuterJoin() {
      return this;
    }
  }, {
    key: 'outerJoin',
    value: function outerJoin() {
      return this;
    }
  }, {
    key: 'fullOuterJoin',
    value: function fullOuterJoin() {
      return this;
    }
  }, {
    key: 'crossJoin',
    value: function crossJoin() {
      return this;
    }
  }, {
    key: 'all',
    value: function all() {
      return new _Promise2.default.resolve(true);
    }
  }, {
    key: 'first',
    value: function first() {
      return new _Promise2.default.resolve(true);
    }
  }, {
    key: 'run',
    value: function run() {
      return new _Promise2.default.resolve(true);
    }
  }, {
    key: 'toModels',
    value: function toModels(results) {
      var _this = this;

      if (!results || !this.collection) {
        return results;
      }

      if (_lodash2.default.isArray(results)) {
        var _ret = (function () {
          var models = [];
          results.forEach(function (model) {
            models.push(_this.collection.model(model));
          });

          return {
            v: models
          };
        })();

        if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
      }

      if (_lodash2.default.isObject(results)) {
        return this.collection.model(results);
      }

      return results;
    }
  }, {
    key: 'toModel',
    value: function toModel() {
      return this.toModels.apply(this, arguments);
    }
  }, {
    key: 'debug',
    value: function debug() {
      return this;
    }
  }, {
    key: 'tap',
    value: function tap(func) {
      func.bind(this)();

      return this;
    }
  }]);

  return Query;
})();

exports.default = Query;