'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })(); /* eslint-disable no-unused-vars */

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _async = require('async');

var _async2 = _interopRequireDefault(_async);

var _Promise = require('./Promise');

var _Promise2 = _interopRequireDefault(_Promise);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Schema = (function () {
  function Schema(adapter) {
    _classCallCheck(this, Schema);

    this.adapter = adapter;
  }

  _createClass(Schema, [{
    key: 'getConnection',
    value: function getConnection() {
      return this.adapter.getConnection();
    }
  }, {
    key: 'dropTableOfCollection',
    value: function dropTableOfCollection(collection) {
      var _this = this;

      var table = collection.table;

      return new _Promise2.default(function (resolve, reject) {
        _async2.default.waterfall([
        // check if exists
        function (callback) {
          _this.tableExists(table).then(function (exists) {
            return callback(null, exists);
          }).catch(function (error) {
            return callback(error);
          });
        },

        // drop it if exists
        function (exists, callback) {
          if (!exists) {
            return callback(null, true);
          }

          _this.dropTable(table).then(function (result) {
            return callback(null, result);
          }).catch(function (error) {
            return callback(error);
          });
        }], function (error, result) {
          if (error) {
            return reject(error);
          }

          resolve(result);
        });
      });
    }
  }, {
    key: 'createTableFromCollection',
    value: function createTableFromCollection(collection) {
      var table = collection.table;
      var collectionSchema = collection.schema;

      return this.createTable(table, collectionSchema);
    }
  }, {
    key: 'dropTable',
    value: function dropTable(tableName) {
      return new _Promise2.default.resolve(true);
    }
  }, {
    key: 'tableExists',
    value: function tableExists(tableName) {
      return new _Promise2.default.resolve(true);
    }
  }, {
    key: 'renameTable',
    value: function renameTable(from, to) {
      return new _Promise2.default.resolve(true);
    }
  }, {
    key: 'createTable',
    value: function createTable(tableName, collectionSchema) {
      return new _Promise2.default.resolve(true);
    }
  }, {
    key: 'columnExists',
    value: function columnExists(tableName, columnName) {
      return new _Promise2.default.resolve(true);
    }
  }, {
    key: 'dropColumn',
    value: function dropColumn(tableName, columnName) {
      return this.dropColumns(tableName, [columnName]);
    }
  }, {
    key: 'dropColumns',
    value: function dropColumns(tableName, columnNames) {
      return new _Promise2.default.resolve(true);
    }
  }, {
    key: 'createColumn',
    value: function createColumn(tableName, columnName, fieldSchema) {
      return this.createColumns(tableName, _defineProperty({}, columnName, fieldSchema));
    }
  }, {
    key: 'createColumns',
    value: function createColumns(tableName, collectionSchema) {
      return new _Promise2.default.resolve(true);
    }
  }, {
    key: 'renameColumn',
    value: function renameColumn(tableName, from, to) {
      return new _Promise2.default.resolve(true);
    }
  }, {
    key: 'alterColumn',
    value: function alterColumn(tableName, columnName, toName, fieldSchema) {
      return new _Promise2.default.resolve(true);
    }
  }, {
    key: 'createIndex',
    value: function createIndex(tableName, columns, indexName, indexType) {
      return new _Promise2.default.resolve(true);
    }
  }, {
    key: 'dropIndex',
    value: function dropIndex(tableName, columns, indexName) {
      return new _Promise2.default.resolve(true);
    }
  }]);

  return Schema;
})();

exports.default = Schema;