'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _2 = require('../../');

var _3 = _interopRequireDefault(_2);

var _Query = require('./Query');

var _Query2 = _interopRequireDefault(_Query);

var _Schema = require('./Schema');

var _Schema2 = _interopRequireDefault(_Schema);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* eslint-disable new-cap */

var Adapter = _3.default.Adapter;

var MemoryAdapter = (function (_Adapter) {
  _inherits(MemoryAdapter, _Adapter);

  function MemoryAdapter() {
    var givenOptions = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

    _classCallCheck(this, MemoryAdapter);

    var options = _extends({
      queryClass: _Query2.default,
      schemaClass: _Schema2.default
    }, givenOptions);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(MemoryAdapter).call(this, options));

    _this.options = options;
    _this.data = {};
    return _this;
  }

  _createClass(MemoryAdapter, [{
    key: 'getData',
    value: function getData() {
      var path = arguments.length <= 0 || arguments[0] === undefined ? null : arguments[0];

      if (!path) {
        return this.data;
      }

      return _lodash2.default.get(this.data, path);
    }
  }, {
    key: 'setData',
    value: function setData() {
      var path = arguments.length <= 0 || arguments[0] === undefined ? null : arguments[0];
      var value = arguments.length <= 1 || arguments[1] === undefined ? null : arguments[1];

      return _lodash2.default.set(this.data, path, value);
    }
  }, {
    key: 'getConnection',
    value: function getConnection() {
      return this.data;
    }
  }]);

  return MemoryAdapter;
})(Adapter);

exports.default = MemoryAdapter;