'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _Query2 = require('../../Query');

var _Query3 = _interopRequireDefault(_Query2);

var _Functions = require('./Functions');

var _Functions2 = _interopRequireDefault(_Functions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { return obj && typeof Symbol !== "undefined" && obj.constructor === Symbol ? "symbol" : typeof obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MemoryQuery = (function (_Query) {
  _inherits(MemoryQuery, _Query);

  function MemoryQuery(givenOptions) {
    _classCallCheck(this, MemoryQuery);

    var options = _extends({
      functionsClass: _Functions2.default
    }, givenOptions);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(MemoryQuery).call(this, options));

    _this.data = _this.adapter.getConnection();

    _this.builder = (0, _lodash2.default)(_this.data);

    if (_this.collection) {
      _this.table(_this.collection.table);
    }
    return _this;
  }

  _createClass(MemoryQuery, [{
    key: 'from',
    value: function from(table) {
      this._from = table;

      return this;
    }
  }, {
    key: 'select',
    value: function select() {
      var _this2 = this;

      if (typeof this._fields === 'undefined') {
        this._fields = [];
      }

      if (typeof this._mapFields === 'undefined') {
        this._mapFields = {};
      }

      if (typeof this._funcFields === 'undefined') {
        this._fieldFuncs = {};
      }

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      if (args.length === 0) {
        return this;
      }

      args.forEach(function (arg) {
        _this2._select(arg);
      });

      return this;
    }
  }, {
    key: '_select',
    value: function _select(field) {
      var _this3 = this;

      if (typeof field === 'string') {
        this._fields.push(field);
      } else if (_lodash2.default.isArray(field)) {
        field.forEach(function (f) {
          _this3._fields.push(f);
        });
      } else if ((typeof field === 'undefined' ? 'undefined' : _typeof(field)) === 'object') {
        _lodash2.default.each(field, function (f, as) {
          if ((typeof f === 'undefined' ? 'undefined' : _typeof(f)) !== 'object' && typeof f !== 'function') {
            _this3._mapFields[f] = as;

            return;
          }

          var funcsList = undefined;
          var fieldName = undefined;

          if ((typeof f === 'undefined' ? 'undefined' : _typeof(f)) === 'object' && f instanceof _Functions2.default) {
            fieldName = f.getColumn();
            funcsList = f.getFunctions();
          } else if (typeof f === 'function') {
            var func = _this3.func.bind(_this3);
            fieldName = f.bind(_this3)(func).getColumn();
            funcsList = f.bind(_this3)(func).getFunctions();
          }

          _this3._fieldFuncs[fieldName] = {
            as: as,
            funcs: funcsList
          };
        });
      }

      return this;
    }
  }, {
    key: 'where',
    value: function where(conditions) {
      this._where = conditions;

      return this;
    }
  }, {
    key: 'groupBy',
    value: function groupBy(givenColumns) {
      var columns = _lodash2.default.isString(givenColumns) ? [givenColumns] : givenColumns;

      this._groupBy = columns;

      return this;
    }
  }, {
    key: 'orderBy',
    value: function orderBy(_orderBy) {
      this._orderBy = _orderBy;

      return this;
    }
  }, {
    key: 'offset',
    value: function offset(_offset) {
      this._offset = _offset;

      return this;
    }
  }, {
    key: 'limit',
    value: function limit(_limit) {
      this._limit = _limit;

      return this;
    }
  }, {
    key: 'page',
    value: function page(_page) {
      if (typeof this._limit === 'undefined') {
        return this;
      }

      var offset = (_page - 1) * this._limit;
      this.offset(offset);

      return this;
    }
  }, {
    key: 'create',
    value: function create(row) {
      this._create = _lodash2.default.isArray(row) ? row : [row];

      return this;
    }
  }, {
    key: 'update',
    value: function update(row) {
      this._update = _lodash2.default.isArray(row) ? row : [row];

      return this;
    }
  }, {
    key: 'delete',
    value: function _delete() {
      this._delete = true;

      return this;
    }
  }, {
    key: 'table',
    value: function table(_table) {
      this._table = _table;

      return this;
    }
  }, {
    key: 'count',
    value: function count() {
      this._count = true;

      return this;
    }
  }, {
    key: 'all',
    value: function all() {
      this._all = true;

      return this.run();
    }
  }, {
    key: 'first',
    value: function first() {
      this._first = true;

      return this.run();
    }
  }, {
    key: 'run',
    value: function run() {
      var value = undefined;

      if (!this._create && !this._update && !this._delete) {
        value = this._runRead();
      } else if (this._create) {
        value = this._runCreate();
      } else if (this._update) {
        value = this._runUpdate();
      } else if (this._delete) {
        value = this._runDelete();
      }

      return new _bluebird2.default.resolve(value);
    }
  }, {
    key: '_runDelete',
    value: function _runDelete() {
      var table = this._table;

      var tableRows = this.adapter.getData(table);
      if (typeof tableRows === 'undefined') {
        tableRows = [];
      }

      var k = _lodash2.default.findIndex(tableRows, this._where);
      var removed = tableRows.splice(k, 1);

      this.adapter.setData(table, tableRows);

      return removed.length;
    }
  }, {
    key: '_runUpdate',
    value: function _runUpdate() {
      var table = this._table;
      var ids = [];

      var tableRows = this.adapter.getData(table);
      if (typeof tableRows === 'undefined') {
        tableRows = [];
      }

      var k = _lodash2.default.findIndex(tableRows, this._where);
      var row = _extends({}, tableRows[k], this._update);
      ids.push(row.id); // @TODO: use collection.primaryKey

      this.adapter.setData(table + '.' + k, row);

      return ids;
    }
  }, {
    key: '_runCreate',
    value: function _runCreate() {
      var _this4 = this;

      var ids = [];
      var table = this._table;

      this._create.forEach(function (row) {
        var tableRows = _this4.adapter.getData(table);

        if (typeof tableRows === 'undefined') {
          tableRows = [];
        }

        if (!row.id) {
          row.id = _lodash2.default.uniqueId(); // @TODO: improve this
        }

        tableRows.push(_extends({}, row));

        _this4.adapter.setData(table, tableRows);
        ids.push(row.id); // @TODO: use collection.primaryKey
      });

      return ids; // IDs
    }
  }, {
    key: '_runRead',
    value: function _runRead() {
      var _this5 = this;

      var results = this.builder.thru(function (data) {
        // from
        if (!_this5._from) {
          return data;
        }

        if (typeof data[_this5._from] !== 'undefined') {
          return data[_this5._from];
        }

        return [];
      }).thru(function (data) {
        // conditions
        if (!_this5._where) {
          return data;
        }

        return _lodash2.default.filter(data, _lodash2.default.matches(_this5._where));
      }).thru(function (data) {
        // ordering
        if (!_this5._orderBy) {
          return data;
        }

        return _lodash2.default.sortByOrder(data, _lodash2.default.keys(_this5._orderBy), _lodash2.default.values(_this5._orderBy));
      }).thru(function (data) {
        // grouping
        if (!_this5._groupBy) {
          return data;
        }

        var column = _lodash2.default.first(_this5._groupBy);
        var grouped = _lodash2.default.groupBy(data, function (row) {
          return row[column];
        });

        var results = [];
        _lodash2.default.each(grouped, function (rows) {
          results.push(rows[0]);
        });

        return results;
      }).thru(function (givenData) {
        // offset and limit
        var data = undefined;

        if (_this5._offset && _this5._limit) {
          data = givenData.slice(_this5._offset, _this5._limit + 1);
        } else if (_this5._limit) {
          data = givenData.slice(0, _this5._limit);
        } else {
          data = givenData;
        }

        return data;
      }).thru(function (data) {
        // select
        if (!data || !_this5._fields && !_this5._mapFields && !_this5._fieldFuncs) {
          return data;
        }

        var rows = data;

        // mapped fields
        rows = _lodash2.default.map(rows, function (row) {
          _lodash2.default.each(_this5._mapFields, function (as, f) {
            row[as] = row[f];
          });

          _lodash2.default.each(_this5._fieldFuncs, function (fieldFunc, f) {
            var as = fieldFunc.as;
            var funcs = fieldFunc.funcs;

            var val = row[f];
            funcs.forEach(function (func) {
              if (typeof _lodash2.default[func] === 'function') {
                val = _lodash2.default[func](val);

                return;
              }

              if (func === 'concat') {
                val = '';
                _this5._concat.forEach(function (concatColumn) {
                  if (concatColumn.indexOf('"') > -1) {
                    val += JSON.parse(concatColumn);

                    return;
                  }

                  val += row[concatColumn];
                });

                return;
              }

              val = String(val)[func]();
            });

            row[as] = val;
          });

          return row;
        });

        // pick the fields
        var pickFields = _this5._fields.concat(_lodash2.default.values(_this5._mapFields)).concat(_lodash2.default.map(_this5._fieldFuncs, function (item) {
          return item.as;
        }));

        if (pickFields.length > 0) {
          rows = _lodash2.default.map(rows, function (row) {
            return _lodash2.default.pick(row, pickFields);
          });
        }

        return rows;
      }).thru(function (data) {
        // all or first
        if (!_this5._first) {
          return data;
        }

        if (typeof data[0] !== 'undefined') {
          return data[0];
        }

        return null;
      }).value();

      if (this._count) {
        return results.length;
      }

      if (!this._all && !this._first) {
        return results;
      }

      return this.toModels(results);
    }
  }]);

  return MemoryQuery;
})(_Query3.default);

exports.default = MemoryQuery;