'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _Expression2 = require('../../Expression');

var _Expression3 = _interopRequireDefault(_Expression2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _typeof(obj) { return obj && typeof Symbol !== "undefined" && obj.constructor === Symbol ? "symbol" : typeof obj; } /* eslint-disable no-use-before-define, no-invalid-this */

function applyConditions(context, method) {
  for (var _len = arguments.length, args = Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
    args[_key - 2] = arguments[_key];
  }

  if (_typeof(args[0]) === 'object') {
    var _context$builder;

    (_context$builder = context.builder)[method].apply(_context$builder, args);
  } else if (typeof args[0] === 'function') {
    context.builder[method](function () {
      var expr = new SqlExpression(context.query, this);
      args[0].apply(context.query, [expr]);
    });
  }

  return context;
}

var SqlExpression = (function (_Expression) {
  _inherits(SqlExpression, _Expression);

  function SqlExpression() {
    var _Object$getPrototypeO;

    _classCallCheck(this, SqlExpression);

    for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    var _this = _possibleConstructorReturn(this, (_Object$getPrototypeO = Object.getPrototypeOf(SqlExpression)).call.apply(_Object$getPrototypeO, [this].concat(args)));

    _this.builder = typeof args[1] !== 'undefined' ? args[1] : null;

    _this.options = typeof args[2] !== 'undefined' ? args[2] : {
      joins: false
    };

    _this.whereMethod = _this.options.joins ? 'on' : 'where';
    return _this;
  }

  _createClass(SqlExpression, [{
    key: 'eq',
    value: function eq(field, value) {
      this.builder[this.whereMethod](field, '=', value);

      return this;
    }
  }, {
    key: 'notEq',
    value: function notEq(field, value) {
      this.builder[this.whereMethod](field, '<>', value);

      return this;
    }
  }, {
    key: 'lt',
    value: function lt(field, value) {
      this.builder[this.whereMethod](field, '<', value);

      return this;
    }
  }, {
    key: 'lte',
    value: function lte(field, value) {
      this.builder[this.whereMethod](field, '<=', value);

      return this;
    }
  }, {
    key: 'gt',
    value: function gt(field, value) {
      this.builder[this.whereMethod](field, '>', value);

      return this;
    }
  }, {
    key: 'gte',
    value: function gte(field, value) {
      this.builder[this.whereMethod](field, '>=', value);

      return this;
    }
  }, {
    key: 'like',
    value: function like(field, value) {
      this.builder[this.whereMethod](field, 'like', value);

      return this;
    }
  }, {
    key: 'notLike',
    value: function notLike(field, value) {
      this.builder.whereNot(field, 'like', value);

      return this;
    }
  }, {
    key: 'in',
    value: function _in(field, values) {
      this.builder[this.whereMethod](field, 'in', values);

      return this;
    }
  }, {
    key: 'notIn',
    value: function notIn(field, values) {
      this.builder.whereNotIn(field, values);

      return this;
    }
  }, {
    key: 'isNull',
    value: function isNull(field) {
      this.builder.whereNull(field);

      return this;
    }
  }, {
    key: 'isNotNull',
    value: function isNotNull(field) {
      this.builder.whereNotNull(field);

      return this;
    }
  }, {
    key: 'between',
    value: function between(field, from, to) {
      this.builder.whereBetween(field, [from, to]);

      return this;
    }
  }, {
    key: 'notBetween',
    value: function notBetween(field, from, to) {
      this.builder.whereNotBetween(field, [from, to]);

      return this;
    }
  }, {
    key: 'and',
    value: function and() {
      for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
        args[_key3] = arguments[_key3];
      }

      return applyConditions.apply(undefined, [this, 'andWhere'].concat(args));
    }
  }, {
    key: 'or',
    value: function or() {
      for (var _len4 = arguments.length, args = Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
        args[_key4] = arguments[_key4];
      }

      return applyConditions.apply(undefined, [this, 'orWhere'].concat(args));
    }
  }, {
    key: 'not',
    value: function not() {
      for (var _len5 = arguments.length, args = Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
        args[_key5] = arguments[_key5];
      }

      return applyConditions.apply(undefined, [this, 'whereNot'].concat(args));
    }
  }]);

  return SqlExpression;
})(_Expression3.default);

exports.default = SqlExpression;