'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _Database = require('./Database');

var _Database2 = _interopRequireDefault(_Database);

var _Adapter = require('./Adapter');

var _Adapter2 = _interopRequireDefault(_Adapter);

var _Collection = require('./Collection');

var _Collection2 = _interopRequireDefault(_Collection);

var _Model = require('./Model');

var _Model2 = _interopRequireDefault(_Model);

var _Behavior = require('./Behavior');

var _Behavior2 = _interopRequireDefault(_Behavior);

var _Query = require('./Query');

var _Query2 = _interopRequireDefault(_Query);

var _Expression = require('./Expression');

var _Expression2 = _interopRequireDefault(_Expression);

var _Functions = require('./Functions');

var _Functions2 = _interopRequireDefault(_Functions);

var _Schema = require('./Schema');

var _Schema2 = _interopRequireDefault(_Schema);

var _Migration = require('./Migration');

var _Migration2 = _interopRequireDefault(_Migration);

var _Promise = require('./Promise');

var _Promise2 = _interopRequireDefault(_Promise);

var _collectionFactory = require('./common/collectionFactory');

var _collectionFactory2 = _interopRequireDefault(_collectionFactory);

var _modelFactory = require('./common/modelFactory');

var _modelFactory2 = _interopRequireDefault(_modelFactory);

var _behaviorFactory = require('./common/behaviorFactory');

var _behaviorFactory2 = _interopRequireDefault(_behaviorFactory);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  Database: _Database2.default,
  Adapter: _Adapter2.default,

  Collection: _Collection2.default,
  Model: _Model2.default,
  Behavior: _Behavior2.default,

  Query: _Query2.default,
  Expression: _Expression2.default,
  Functions: _Functions2.default,

  Schema: _Schema2.default,
  Migration: _Migration2.default,

  Promise: _Promise2.default,

  createCollection: (0, _collectionFactory2.default)(),
  createModel: (0, _modelFactory2.default)(),
  createBehavior: (0, _behaviorFactory2.default)()
};